<!DOCTYPE html>
<html lang="en">

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<style>
    input {
        background-color: #b3cee5;
        border: none;
    }
</style>

<body>
    <div class="container">
        <h3 class="text-center">F200-LỊCH SỬ QUAY DICE</h3>
        <div class="bg-secondary my-4">
            <div><b class="thong-tin-nguoi-choi-b">Thông tin người chơi</b></div>
            <div class="filter-place">
                <form class="row">
                    <div class="col-4 my-3">
                        <label for="username-input-filter">Username</label>
                        <input id="username-input-filter">
                    </div>
                    <div class="col-4 my-3">
                        <label for="firstname-input-filter">Firstname</label>
                        <input id="firstname-input-filter">
                    </div>
                    <div class="col-4 my-3">
                        <label for="lastname-input-filter">Lastname</label>
                        <input id="lastname-input-filter">
                    </div>
                </form>
            </div>
        </div>
        <table class="dice-table table table-hover table-striped table-bordered" id="dice-table">
            <thead class="table-primary">
                <tr>
                    <th>LẦN CHƠI</th>
                    <th>KẾT QUẢ</th>
                </tr>
            </thead>
        </table>
    </div>
</body>
<script>
    const baseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice";
    var gDiceHistoryData = [];
    const gDATA = ['game', 'dice'];
    const gSTT_COL = 0 ;
    const gDICE_COL = 1;
    var gStt = 1;

    $(document).ready(function () {
        onPageLoading();
    })
    var gTable = $("#dice-table").DataTable({
        columns: [
            {data: gDATA[gSTT_COL]},
            {data: gDATA[gDICE_COL]},
        ],
        columnDefs:[
            {
                targets: gSTT_COL,
                render: (data) => {return gStt++}
            },
            {
                targets: gDICE_COL,
                className: 'text-center'
            }
        ]
    })


    function onPageLoading() {
        loadInformationIntoInput();
    }

    function loadInformationIntoInput() {
        var vUrlString = new URL(window.location.href);
        var vUsername = vUrlString.searchParams.get('user_name');
        var vFirstname = vUrlString.searchParams.get('first_name');
        var vLastname = vUrlString.searchParams.get('last_name');

        loadUserName(vUsername,vFirstname,vLastname);

        callApiToLoadPlayer(vUsername);
    }

    function loadDataToDiceTable(paramObject){
        gTable.clear();
        gTable.rows.add(paramObject);
        gTable.draw();
    }

    function callApiToLoadPlayer(paramUsername) {
        $.ajax({
            url: baseUrl + "/dice-history?username=" + paramUsername,
            type: "Get",
            success: function (res) {
                console.log("responseText >>>" + JSON.stringify(res));
                if(res.dices.length > 0){
                    var vCount = 1;
                    while(vCount < res.dices.length){
                        var bDice = {'game': vCount, 'dice': res.dices[vCount]};
                        gDiceHistoryData.push(bDice);
                        vCount++;
                    }
                    loadDataToDiceTable(gDiceHistoryData);
                }
            },
            error: function (error) {
                console.log(error);
            }
        })
    }

    function loadUserName(paramUsername, paramFirstname, paramLastname){
        $("#username-input-filter").val(paramUsername);
        $("#firstname-input-filter").val(paramFirstname);
        $("#lastname-input-filter").val(paramLastname);
    }
</script>

</html>